function [f, g] = minimize_max_affine(omega,pars)
% Emre Mengi (Modified on July 23rd, 2013)
%
% to minimize the largest eigenvalue of
%	L(omega) = A0 + sum_{j=1,d} omega_j Aj
%
% coefficient matrices: Aj = pars.A(:,:,j+1) j=1,...,d

MA = pars.A;
[m,n,p] = size(MA);
l = length(omega);

if ((n ~= m) | (p-1 ~= l))
	error('the input matrix must be square');
end


A = MA(:,:,1);
for j = 2:p
	A = A + omega(j-1,1)*MA(:,:,j);
end



if (n <= 150)


	[V,D] = eig(A);

	f = D(n,n);


	for j = 1:p-1
		g(j,1) = real(V(:,n)'*MA(:,:,j+1)*V(:,n));
	end
else
			 
	[eigvec,d] = eigs(A,1,'lm');

	vm = eigvec(1:n,1);
	vm = vm/norm(vm);

	f = real(d(1,1));
	
	for j = 1:p-1
		g(j,1) = real(V(:,n)'*MA(:,:,j)*V(:,n));
	end				  

end




return;