function [f, g] = dist_triple_poly(gamma,pars)
% Emre Mengi (Modified August 19, 2011)
%
% call: [f, g] = dist_triple_poly(gamma,pars)


[n,n2,m] = size(pars.P);
P = pars.P;

Pfun = pars.P(:,:,1);
for j = 1:m-1
	Pfun = Pfun + pars.lambda^j*P(:,:,j+1);
end


Pp = pars.P(:,:,2);
for j = 2:m-1
	Pp = Pp + j*pars.lambda^(j-1)*pars.P(:,:,j+1);
end

Ppp = 2*pars.P(:,:,3);
for j = 3:m-1
	Ppp = Ppp + j*(j-1)*pars.lambda^(j-2)*pars.P(:,:,j+1);
end



Zn = zeros(n);

B = [	Pfun   (gamma(1)+i*gamma(4))*Pp		[(gamma(1)+i*gamma(4))*(gamma(3) + i*gamma(6))/2]*Ppp + (gamma(2)+i*gamma(5))*Pp;
	 Zn		Pfun								(gamma(3) + i*gamma(6))*Pp;		
	 Zn		Zn									Pfun							];

[U,S,V] = svd(B);

S = diag(S);
[S,ind] = sort(S);

vm = V(:,ind(3));
vm = vm/norm(vm);
um = U(:,ind(3));
um = um/norm(um);



f = -S(3);
g(1,1) = -real(um(1:n)'* Pp *vm(n+1:2*n)) - real(um(1:n)'* ((gamma(3) + i*gamma(6))/2)*Ppp *vm(2*n+1:3*n));
g(4,1) =  imag(um(1:n)'* Pp *vm(n+1:2*n)) + imag(um(1:n)'* ((gamma(3) + i*gamma(6))/2)*Ppp *vm(2*n+1:3*n));			   	   
			   
g(2,1) = -real(um(1:n)'*Pp*vm(2*n+1:3*n));
g(5,1) =  imag(um(1:n)'*Pp*vm(2*n+1:3*n));

g(3,1) = -real(um(n+1:2*n)'* Pp *vm(2*n+1:3*n)) - real(um(1:n)'* ((gamma(1) + i*gamma(4))/2)*Ppp *vm(2*n+1:3*n));
g(6,1) =  imag(um(n+1:2*n)'* Pp *vm(2*n+1:3*n)) + imag(um(1:n)'* ((gamma(1) + i*gamma(4))/2)*Ppp *vm(2*n+1:3*n));


return;